// C++ code by miniil
//

#include <Keypad.h>

const byte ROWS = 4;
const byte COLUMNS = 4;

const int L4 = 8; 
const int L3 = 9; 
const int L2 = 10; 
const int L1 = 11; 

const int C4 = 2; 
const int C3 = 3; 
const int C2 = 4; 
const int C1 = 5; 

//Key definition
char keys[ROWS][COLUMNS] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};

//Array rows and columns
byte pinRows[ROWS] = {L1, L2, L3, L4}; //connections for rows
byte pinColumns[COLUMNS] = {C1, C2, C3, C4}; //connections for columns

char key; //keep the key

//Keypad object creation
Keypad keypad = Keypad( makeKeymap(keys), pinRows, pinColumns, ROWS, COLUMNS);

void setup()
{
  Serial.begin(9600);
  testKeyPad();
}

void loop()
{
  //Empty
}

void testKeyPad()
{
  char key;
  String keyEntered = "";
  while (key != '#')
  {
    key = keypad.getKey();
    if (key != NO_KEY && key != '#')
    {
      Serial.println(key);
      keyEntered += key;
      Serial.println(keyEntered);
      delay(300);
    }
  }

  Serial.println(keyEntered);
}